<?php


namespace app\bot\controller;
use app\common\model\kefu\ChatLog;
use app\common\model\kefu\Kefu as KefuModel;
use app\common\model\kefu\Config;
use app\admin\model\Admin as AdminM;
use ky\Logger;
class Kefu extends Addon
{
    private $switch;
    private $toWxid = '';
    /**
     * @var Config
     */
    private $configM;

    public function init($options = [])
    {
        parent::init($options); // TODO: Change the autogenerated stub
        $this->configM = new Config();
        $this->configs = $this->configM->getConf(['admin_id' => AdminM::getFounderId(),'bot_id' => 0]);//系统配置
        $this->switch = $this->configs['switch']??false;
        return $this;
    }


    /**
     * 私聊处理器
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function privateChatHandle(){
//        echo "私聊处理器---".date("Y-m-d H:i:s");
        //Logger::write("私聊处理器---".date("Y-m-d H:i:s"));
        if(empty($this->switch)){
            return false;
        }
        $this->toWxid = $this->fromWxid;
        //保存私聊消息
        $model_chat_log = new ChatLog();
        $model_chat_log->saveChat($this->content,$this->bot);
    }

    /**
     * 
     * 好友请求处理器
     */
    public function friendVerifyHandle(){
        //Logger::write("好友请求处理器---");
        if(empty($this->switch)){
            return false;
        }
        //自动通过好友验证
        $model_kefu = new KefuModel();
        $botConfigs = $this->configM->getConf(['admin_id' => AdminM::getFounderId(),'bot_id' => $this->bot['id']]);//机器人配置
        $model_kefu->autoPass($this->content,$this->bot,$this->botClient,$botConfigs);
    }

    /**
     * 
     * 回调处理器
     */
    public function deviceCallbackHandle(){
        // Logger::write("回调处理器---".date("Y-m-d"));
        // Logger::write(json_encode($this->bot));
        if(empty($this->switch)){
            return false;
        }
        // Logger::write("111");
        //保存手机发送消息
        $model_chat_log = new ChatLog();
        $model_chat_log->saveMobileMsg($this->content,$this->bot);
    }


    /**
     * 
     * 群聊接收回调处理器
     */
    public function groupChatHandle(){
        //Logger::write("群聊接收回调处理器---");
        if(empty($this->switch)){
            return false;
        }
        //群聊接收数据,发送客户端
        $model_chat_log = new ChatLog();
        $model_chat_log->saveGroupChat($this->content,$this->bot);
    }
}
